/*
 * Copyright (C) 2020 Activision Publishing, Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials
 *    provided with the distribution.
 *
 * 3. Neither the name of Activision Publishing, Inc. nor the names of
 *    its contributors may be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef __TELESCOPE_PLATFORM_DEFS_H__
#define __TELESCOPE_PLATFORM_DEFS_H__

#define TELESCOPE(TELESCOPE_FEATURE) (defined( TELESCOPE_##TELESCOPE_FEATURE ) && TELESCOPE_##TELESCOPE_FEATURE)

// Device categories & types
#if defined IS_PS4
#define TELESCOPE_PS_PROGRAM		1
#define TELESCOPE_PS4_PROGRAM		1
#define TELESCOPE_PS5_PROGRAM		0
#define TELESCOPE_XB_PROGRAM		0
#define TELESCOPE_XB3_PROGRAM		0
#define TELESCOPE_XB4_PROGRAM		0
#define TELESCOPE_PC_PROGRAM		0
#elif defined IS_PS5
#define TELESCOPE_PS_PROGRAM		1
#define TELESCOPE_PS4_PROGRAM		0
#define TELESCOPE_PS5_PROGRAM		1
#define TELESCOPE_XB_PROGRAM		0
#define TELESCOPE_XB3_PROGRAM		0
#define TELESCOPE_XB4_PROGRAM		0
#define TELESCOPE_PC_PROGRAM		0
#elif defined IS_XB3
#define TELESCOPE_PS_PROGRAM		0
#define TELESCOPE_PS4_PROGRAM		0
#define TELESCOPE_PS5_PROGRAM		0
#define TELESCOPE_XB_PROGRAM		1
#define TELESCOPE_XB3_PROGRAM		1
#define TELESCOPE_XB4_PROGRAM		0
#define TELESCOPE_PC_PROGRAM		0
#elif defined IS_XB4
#define TELESCOPE_PS_PROGRAM		0
#define TELESCOPE_PS4_PROGRAM		0
#define TELESCOPE_PS5_PROGRAM		0
#define TELESCOPE_XB_PROGRAM		1
#define TELESCOPE_XB3_PROGRAM		0
#define TELESCOPE_XB4_PROGRAM		1
#define TELESCOPE_PC_PROGRAM		0
#elif defined IS_PC
#define TELESCOPE_PS_PROGRAM		0
#define TELESCOPE_PS4_PROGRAM		0
#define TELESCOPE_PS5_PROGRAM		0
#define TELESCOPE_XB_PROGRAM		0
#define TELESCOPE_XB3_PROGRAM		0
#define TELESCOPE_XB4_PROGRAM		0
#define TELESCOPE_PC_PROGRAM		1
#endif

// Console devices
#if TELESCOPE( PS_PROGRAM ) || TELESCOPE( XB_PROGRAM )
#define TELESCOPE_CONSOLE_PROGRAM	1
#else
#define TELESCOPE_CONSOLE_PROGRAM	0
#endif

// Manufacturer platforms
#if TELESCOPE( PC_PROGRAM ) || TELESCOPE( XB_PROGRAM )
#define TELESCOPE_MICROSOFT_PROGRAM	1
#define TELESCOPE_SONY_PROGRAM		0
#elif TELESCOPE( PS_PROGRAM )
#define TELESCOPE_MICROSOFT_PROGRAM	0
#define TELESCOPE_SONY_PROGRAM		1
#endif

// Configurations
#if defined(IS_DEBUG)
#define TELESCOPE_DEBUG             1
#define TELESCOPE_DEV				1
#elif defined(IS_RELEASE)
#define TELESCOPE_DEBUG             0
#define TELESCOPE_DEV				1
#elif defined(IS_SHIP)
#define TELESCOPE_DEBUG             0
#define TELESCOPE_DEV				0
#else
#error "Unknown configuration"
#endif

#endif // __TELESCOPE_PLATFORM_DEFS_H__